/*
 * COPYRIGHT:            See COPYING in the top level directory
 * PROJECT:              ReactOS kernel
 * FILE:                 lib/opengl32/glfuncs.h
 * PURPOSE:              OpenGL32 lib, GLFUNCS_MACRO
 * PROGRAMMER:           gen_glfuncs_macro.sh
 * UPDATE HISTORY:
 *               !!! AUTOMATICALLY CREATED FROM glfuncs.csv !!!
 */

/* To use this macro define a macro X(name, ret, typeargs, args, icdidx, tebidx, stack).
 * It gets called for every glXXX function. i.e. glVertex3f: name = "glVertex3f",
 * ret = "void", typeargs = "(GLfloat x, GLfloat y, GLfloat z)", args = "(x,y,z)",
 * icdidx = "136", tebidx = "98" and stack = "12".
 * Don't forget to undefine X ;-)
 */

XVOID(glAccum,(GLenum op, GLfloat value), (op,value),  213,  8)
XVOID(glAlphaFunc, (GLenum func, GLclampf ref), (func,ref),  240,  8)
X(glAreTexturesResident, GLboolean, (GLsizei n, const GLuint *textures, GLboolean *residences), (n,textures,residences),  322,  12)
XVOID(glBitmap, (GLsizei width, GLsizei height, GLfloat xorig, GLfloat yorig, GLfloat xmove, GLfloat ymove, const GLubyte *bitmap), (width,height,xorig,yorig,xmove,ymove,bitmap),  8,  28)
XVOID(glBlendFunc, (GLenum sfactor, GLenum dfactor), (sfactor,dfactor),  241,  8)
XVOID(glClear, (GLbitfield mask), (mask),  203,  4)
XVOID(glClearAccum, (GLfloat red, GLfloat green, GLfloat blue, GLfloat alpha), (red,green,blue,alpha),  204,  16)
XVOID(glClearColor, (GLclampf red, GLclampf green, GLclampf blue, GLclampf alpha), (red,green,blue,alpha),  206,  16)
XVOID(glClearDepth, (GLclampd depth), (depth),  208,  8)
XVOID(glClearIndex, (GLfloat c), (c),  205,  4)
XVOID(glClearStencil, (GLint s), (s),  207,  4)
XVOID(glClipPlane, (GLenum plane, const GLdouble *equation), (plane,equation),  150,  8)
XVOID(glColorMask, (GLboolean red, GLboolean green, GLboolean blue, GLboolean alpha), (red,green,blue,alpha),  210,  16)
XVOID(glColorMaterial, (GLenum face, GLenum mode), (face,mode),  151,  8)
XVOID(glCopyPixels, (GLint x, GLint y, GLsizei width, GLsizei height, GLenum type), (x,y,width,height,type),  255,  20)
XVOID(glCopyTexImage1D, (GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLint border), (target,level,internalformat,x,y,width,border),  323,  28)
XVOID(glCopyTexImage2D, (GLenum target, GLint level, GLenum internalformat, GLint x, GLint y, GLsizei width, GLsizei height, GLint border), (target,level,internalformat,x,y,width,height,border),  324,  32)
XVOID(glCopyTexSubImage1D, (GLenum target, GLint level, GLint xoffset, GLint x, GLint y, GLsizei width), (target,level,xoffset,x,y,width),  325,  24)
XVOID(glCopyTexSubImage2D, (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLint x, GLint y, GLsizei width, GLsizei height), (target,level,xoffset,yoffset,x,y,width,height),  326,  32)
XVOID(glCullFace, (GLenum mode), (mode),  152,  4)
XVOID(glDeleteLists, (GLuint list, GLsizei range), (list,range),  4,  8)
XVOID(glDeleteTextures, (GLsizei n, const GLuint *textures), (n,textures),  327,  8)
XVOID(glDepthFunc, (GLenum func), (func),  245,  4)
XVOID(glDepthMask, (GLboolean flag), (flag),  211,  4)
XVOID(glDepthRange, (GLclampd zNear, GLclampd zFar), (zNear,zFar),  288,  16)
XVOID(glDrawBuffer, (GLenum mode), (mode),  202,  4)
XVOID(glDrawPixels, (GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *pixels), (width,height,format,type,pixels),  257,  20)
XVOID(glEndList, (void), (),  1,  0)
XVOID(glEvalMesh1, (GLenum mode, GLint i1, GLint i2), (mode,i1,i2),  236,  12)
XVOID(glEvalMesh2, (GLenum mode, GLint i1, GLint i2, GLint j1, GLint j2), (mode,i1,i2,j1,j2),  238,  20)
XVOID(glFeedbackBuffer, (GLsizei size, GLenum type, GLfloat *buffer), (size,type,buffer),  194,  12)
XVOID(glFinish, (void), (),  216,  0)
XVOID(glFlush, (void), (),  217,  0)
XVOID(glFogf, (GLenum pname, GLfloat param), (pname,param),  153,  8)
XVOID(glFogfv, (GLenum pname, const GLfloat *params), (pname,params),  154,  8)
XVOID(glFogi, (GLenum pname, GLint param), (pname,param),  155,  8)
XVOID(glFogiv, (GLenum pname, const GLint *params), (pname,params),  156,  8)
XVOID(glFrontFace, (GLenum mode), (mode),  157,  4)
XVOID(glFrustum, (GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar), (left,right,bottom,top,zNear,zFar),  289,  48)
X(glGenLists, GLuint, (GLsizei range), (range),  5,  4)
XVOID(glGenTextures, (GLsizei n, GLuint *textures), (n,textures),  328,  8)
XVOID(glGetBooleanv, (GLenum pname, GLboolean *params), (pname,params),  258,  8)
XVOID(glGetClipPlane, (GLenum plane, GLdouble *equation), (plane,equation),  259,  8)
XVOID(glGetDoublev, (GLenum pname, GLdouble *params), (pname,params),  260,  8)
X(glGetError, GLenum, (void), (),  261,  0)
XVOID(glGetFloatv, (GLenum pname, GLfloat *params), (pname,params),  262,  8)
XVOID(glGetIntegerv, (GLenum pname, GLint *params), (pname,params),  263,  8)
XVOID(glGetLightfv, (GLenum light, GLenum pname, GLfloat *params), (light,pname,params),  264,  12)
XVOID(glGetLightiv, (GLenum light, GLenum pname, GLint *params), (light,pname,params),  265,  12)
XVOID(glGetMapdv, (GLenum target, GLenum query, GLdouble *v), (target,query,v),  266,  12)
XVOID(glGetMapfv, (GLenum target, GLenum query, GLfloat *v), (target,query,v),  267,  12)
XVOID(glGetMapiv, (GLenum target, GLenum query, GLint *v), (target,query,v),  268,  12)
XVOID(glGetMaterialfv, (GLenum face, GLenum pname, GLfloat *params), (face,pname,params),  269,  12)
XVOID(glGetMaterialiv, (GLenum face, GLenum pname, GLint *params), (face,pname,params),  270,  12)
XVOID(glGetPixelMapfv, (GLenum map, GLfloat *values), (map,values),  271,  8)
XVOID(glGetPixelMapuiv, (GLenum map, GLuint *values), (map,values),  272,  8)
XVOID(glGetPixelMapusv, (GLenum map, GLushort *values), (map,values),  273,  8)
XVOID(glGetPolygonStipple, (GLubyte *mask), (mask),  274,  4)
X(glGetString, const GLubyte* , (GLenum name), (name),  275,  4)
XVOID(glGetTexEnvfv, (GLenum target, GLenum pname, GLfloat *params), (target,pname,params),  276,  12)
XVOID(glGetTexEnviv, (GLenum target, GLenum pname, GLint *params), (target,pname,params),  277,  12)
XVOID(glGetTexGendv, (GLenum coord, GLenum pname, GLdouble *params), (coord,pname,params),  278,  12)
XVOID(glGetTexGenfv, (GLenum coord, GLenum pname, GLfloat *params), (coord,pname,params),  279,  12)
XVOID(glGetTexGeniv, (GLenum coord, GLenum pname, GLint *params), (coord,pname,params),  280,  12)
XVOID(glGetTexImage, (GLenum target, GLint level, GLenum format, GLenum type, GLvoid *pixels), (target,level,format,type,pixels),  281,  20)
XVOID(glGetTexLevelParameterfv, (GLenum target, GLint level, GLenum pname, GLfloat *params), (target,level,pname,params),  284,  16)
XVOID(glGetTexLevelParameteriv, (GLenum target, GLint level, GLenum pname, GLint *params), (target,level,pname,params),  285,  16)
XVOID(glGetTexParameterfv, (GLenum target, GLenum pname, GLfloat *params), (target,pname,params),  282,  12)
XVOID(glGetTexParameteriv, (GLenum target, GLenum pname, GLint *params), (target,pname,params),  283,  12)
XVOID(glHint, (GLenum target, GLenum mode), (target,mode),  158,  8)
XVOID(glIndexMask, (GLuint mask), (mask),  212,  4)
XVOID(glInitNames, (void), (),  197,  0)
X(glIsEnabled, GLboolean, (GLenum cap), (cap),  286,  4)
X(glIsList, GLboolean, (GLuint list), (list),  287,  4)
X(glIsTexture, GLboolean, (GLuint texture), (texture),  330,  4)
XVOID(glLightModelf, (GLenum pname, GLfloat param), (pname,param),  163,  8)
XVOID(glLightModelfv, (GLenum pname, const GLfloat *params), (pname,params),  164,  8)
XVOID(glLightModeli, (GLenum pname, GLint param), (pname,param),  165,  8)
XVOID(glLightModeliv, (GLenum pname, const GLint *params), (pname,params),  166,  8)
XVOID(glLightf, (GLenum light, GLenum pname, GLfloat param), (light,pname,param),  159,  12)
XVOID(glLightfv, (GLenum light, GLenum pname, const GLfloat *params), (light,pname,params),  160,  12)
XVOID(glLighti, (GLenum light, GLenum pname, GLint param), (light,pname,param),  161,  12)
XVOID(glLightiv, (GLenum light, GLenum pname, const GLint *params), (light,pname,params),  162,  12)
XVOID(glLineStipple, (GLint factor, GLushort pattern), (factor,pattern),  167,  8)
XVOID(glLineWidth, (GLfloat width), (width),  168,  4)
XVOID(glListBase, (GLuint base), (base),  6,  4)
XVOID(glLoadName, (GLuint name), (name),  198,  4)
XVOID(glLogicOp, (GLenum opcode), (opcode),  242,  4)
XVOID(glMap1d, (GLenum target, GLdouble u1, GLdouble u2, GLint stride, GLint order, const GLdouble *points), (target,u1,u2,stride,order,points),  220,  32)
XVOID(glMap1f, (GLenum target, GLfloat u1, GLfloat u2, GLint stride, GLint order, const GLfloat *points), (target,u1,u2,stride,order,points),  221,  24)
XVOID(glMap2d, (GLenum target, GLdouble u1, GLdouble u2, GLint ustride, GLint uorder, GLdouble v1, GLdouble v2, GLint vstride, GLint vorder, const GLdouble *points), (target,u1,u2,ustride,uorder,v1,v2,vstride,vorder,points),  222,  56)
XVOID(glMap2f, (GLenum target, GLfloat u1, GLfloat u2, GLint ustride, GLint uorder, GLfloat v1, GLfloat v2, GLint vstride, GLint vorder, const GLfloat *points), (target,u1,u2,ustride,uorder,v1,v2,vstride,vorder,points),  223,  40)
XVOID(glMapGrid1d, (GLint un, GLdouble u1, GLdouble u2), (un,u1,u2),  224,  20)
XVOID(glMapGrid1f, (GLint un, GLfloat u1, GLfloat u2), (un,u1,u2),  225,  12)
XVOID(glMapGrid2d, (GLint un, GLdouble u1, GLdouble u2, GLint vn, GLdouble v1, GLdouble v2), (un,u1,u2,vn,v1,v2),  226,  40)
XVOID(glMapGrid2f, (GLint un, GLfloat u1, GLfloat u2, GLint vn, GLfloat v1, GLfloat v2), (un,u1,u2,vn,v1,v2),  227,  24)
XVOID(glNewList, (GLuint list, GLenum mode), (list,mode),  0,  8)
XVOID(glOrtho, (GLdouble left, GLdouble right, GLdouble bottom, GLdouble top, GLdouble zNear, GLdouble zFar), (left,right,bottom,top,zNear,zFar),  296,  48)
XVOID(glPassThrough, (GLfloat token), (token),  199,  4)
XVOID(glPixelMapfv, (GLenum map, GLint mapsize, const GLfloat *values), (map,mapsize,values),  251,  12)
XVOID(glPixelMapuiv, (GLenum map, GLint mapsize, const GLuint *values), (map,mapsize,values),  252,  12)
XVOID(glPixelMapusv, (GLenum map, GLint mapsize, const GLushort *values), (map,mapsize,values),  253,  12)
XVOID(glPixelStoref, (GLenum pname, GLfloat param), (pname,param),  249,  8)
XVOID(glPixelStorei, (GLenum pname, GLint param), (pname,param),  250,  8)
XVOID(glPixelTransferf, (GLenum pname, GLfloat param), (pname,param),  247,  8)
XVOID(glPixelTransferi, (GLenum pname, GLint param), (pname,param),  248,  8)
XVOID(glPixelZoom, (GLfloat xfactor, GLfloat yfactor), (xfactor,yfactor),  246,  8)
XVOID(glPointSize, (GLfloat size), (size),  173,  4)
XVOID(glPolygonMode, (GLenum face, GLenum mode), (face,mode),  174,  8)
XVOID(glPolygonStipple, (const GLubyte *mask), (mask),  175,  4)
XVOID(glPopName, (void), (),  200,  0)
XVOID(glPrioritizeTextures, (GLsizei n, const GLuint *textures, const GLclampf *priorities), (n,textures,priorities),  331,  12)
XVOID(glPushName, (GLuint name), (name),  201,  4)
XVOID(glRasterPos2d, (GLdouble x, GLdouble y), (x,y),  62,  16)
XVOID(glRasterPos2dv, (const GLdouble *v), (v),  63,  4)
XVOID(glRasterPos2f, (GLfloat x, GLfloat y), (x,y),  64,  8)
XVOID(glRasterPos2fv, (const GLfloat *v), (v),  65,  4)
XVOID(glRasterPos2i, (GLint x, GLint y), (x,y),  66,  8)
XVOID(glRasterPos2iv, (const GLint *v), (v),  67,  4)
XVOID(glRasterPos2s, (GLshort x, GLshort y), (x,y),  68,  8)
XVOID(glRasterPos2sv, (const GLshort *v), (v),  69,  4)
XVOID(glRasterPos3d, (GLdouble x, GLdouble y, GLdouble z), (x,y,z),  70,  24)
XVOID(glRasterPos3dv, (const GLdouble *v), (v),  71,  4)
XVOID(glRasterPos3f, (GLfloat x, GLfloat y, GLfloat z), (x,y,z),  72,  12)
XVOID(glRasterPos3fv, (const GLfloat *v), (v),  73,  4)
XVOID(glRasterPos3i, (GLint x, GLint y, GLint z), (x,y,z),  74,  12)
XVOID(glRasterPos3iv, (const GLint *v), (v),  75,  4)
XVOID(glRasterPos3s, (GLshort x, GLshort y, GLshort z), (x,y,z),  76,  12)
XVOID(glRasterPos3sv, (const GLshort *v), (v),  77,  4)
XVOID(glRasterPos4d, (GLdouble x, GLdouble y, GLdouble z, GLdouble w), (x,y,z,w),  78,  32)
XVOID(glRasterPos4dv, (const GLdouble *v), (v),  79,  4)
XVOID(glRasterPos4f, (GLfloat x, GLfloat y, GLfloat z, GLfloat w), (x,y,z,w),  80,  16)
XVOID(glRasterPos4fv, (const GLfloat *v), (v),  81,  4)
XVOID(glRasterPos4i, (GLint x, GLint y, GLint z, GLint w), (x,y,z,w),  82,  16)
XVOID(glRasterPos4iv, (const GLint *v), (v),  83,  4)
XVOID(glRasterPos4s, (GLshort x, GLshort y, GLshort z, GLshort w), (x,y,z,w),  84,  16)
XVOID(glRasterPos4sv, (const GLshort *v), (v),  85,  4)
XVOID(glReadBuffer, (GLenum mode), (mode),  254,  4)
XVOID(glReadPixels, (GLint x, GLint y, GLsizei width, GLsizei height, GLenum format, GLenum type, GLvoid *pixels), (x,y,width,height,format,type,pixels),  256,  28)
XVOID(glRectd, (GLdouble x1, GLdouble y1, GLdouble x2, GLdouble y2), (x1,y1,x2,y2),  86,  32)
XVOID(glRectdv, (const GLdouble *v1, const GLdouble *v2), (v1,v2),  87,  8)
XVOID(glRectf, (GLfloat x1, GLfloat y1, GLfloat x2, GLfloat y2), (x1,y1,x2,y2),  88,  16)
XVOID(glRectfv, (const GLfloat *v1, const GLfloat *v2), (v1,v2),  89,  8)
XVOID(glRecti, (GLint x1, GLint y1, GLint x2, GLint y2), (x1,y1,x2,y2),  90,  16)
XVOID(glRectiv, (const GLint *v1, const GLint *v2), (v1,v2),  91,  8)
XVOID(glRects, (GLshort x1, GLshort y1, GLshort x2, GLshort y2), (x1,y1,x2,y2),  92,  16)
XVOID(glRectsv, (const GLshort *v1, const GLshort *v2), (v1,v2),  93,  8)
X(glRenderMode, GLint, (GLenum mode), (mode),  196,  4)
XVOID(glScissor, (GLint x, GLint y, GLsizei width, GLsizei height), (x,y,width,height),  176,  16)
XVOID(glSelectBuffer, (GLsizei size, GLuint *buffer), (size,buffer),  195,  8)
XVOID(glShadeModel, (GLenum mode), (mode),  177,  4)
XVOID(glStencilFunc, (GLenum func, GLint ref, GLuint mask), (func,ref,mask),  243,  12)
XVOID(glStencilMask, (GLuint mask), (mask),  209,  4)
XVOID(glStencilOp, (GLenum fail, GLenum zfail, GLenum zpass), (fail,zfail,zpass),  244,  12)
XVOID(glTexEnvf, (GLenum target, GLenum pname, GLfloat param), (target,pname,param),  184,  12)
XVOID(glTexEnvfv, (GLenum target, GLenum pname, const GLfloat *params), (target,pname,params),  185,  12)
XVOID(glTexEnvi, (GLenum target, GLenum pname, GLint param), (target,pname,param),  186,  12)
XVOID(glTexEnviv, (GLenum target, GLenum pname, const GLint *params), (target,pname,params),  187,  12)
XVOID(glTexGend, (GLenum coord, GLenum pname, GLdouble param), (coord,pname,param),  188,  16)
XVOID(glTexGendv, (GLenum coord, GLenum pname, const GLdouble *params), (coord,pname,params),  189,  12)
XVOID(glTexGenf, (GLenum coord, GLenum pname, GLfloat param), (coord,pname,param),  190,  12)
XVOID(glTexGenfv, (GLenum coord, GLenum pname, const GLfloat *params), (coord,pname,params),  191,  12)
XVOID(glTexGeni, (GLenum coord, GLenum pname, GLint param), (coord,pname,param),  192,  12)
XVOID(glTexGeniv, (GLenum coord, GLenum pname, const GLint *params), (coord,pname,params),  193,  12)
XVOID(glTexImage1D, (GLenum target, GLint level, GLint internalformat, GLsizei width, GLint border, GLenum format, GLenum type, const GLvoid *pixels), (target,level,internalformat,width,border,format,type,pixels),  182,  32)
XVOID(glTexImage2D, (GLenum target, GLint level, GLint internalformat, GLsizei width, GLsizei height, GLint border, GLenum format, GLenum type, const GLvoid *pixels), (target,level,internalformat,width,height,border,format,type,pixels),  183,  36)
XVOID(glTexParameterf, (GLenum target, GLenum pname, GLfloat param), (target,pname,param),  178,  12)
XVOID(glTexParameterfv, (GLenum target, GLenum pname, const GLfloat *params), (target,pname,params),  179,  12)
XVOID(glTexParameteri, (GLenum target, GLenum pname, GLint param), (target,pname,param),  180,  12)
XVOID(glTexParameteriv, (GLenum target, GLenum pname, const GLint *params), (target,pname,params),  181,  12)
XVOID(glTexSubImage1D, (GLenum target, GLint level, GLint xoffset, GLsizei width, GLenum format, GLenum type, const GLvoid *pixels), (target,level,xoffset,width,format,type,pixels),  332,  28)
XVOID(glTexSubImage2D, (GLenum target, GLint level, GLint xoffset, GLint yoffset, GLsizei width, GLsizei height, GLenum format, GLenum type, const GLvoid *pixels), (target,level,xoffset,yoffset,width,height,format,type,pixels),  333,  36)
XVOID(glViewport, (GLint x, GLint y, GLsizei width, GLsizei height), (x,y,width,height),  305,  16)

/* EOF */
